﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Olap.Xmla;
using Infragistics.Olap.Data;
using Infragistics.Olap;
using Infragistics.Controls;
using Infragistics.Controls.Grids;
using System.Threading.Tasks;

namespace Pivot_Analysis
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        XmlaDataSource datasource;
        public MainWindow()
        {
            InitializeComponent();

            datasource = new XmlaDataSource() { ServerUri = new Uri("http://sampledata.infragistics.com/olap/msmdpump.dll") };
            datasource.Database = XmlaDataSource.GenerateInitialDatabase("Adventure Works DW Standard Edition");
            datasource.Cube = XmlaDataSource.GenerateInitialCube("Adventure Works");
            datasource.Initialized += new EventHandler<EventArgs>(datasource_Initialized);
			datasource.LoadSchemaAsync();
        }

        void datasource_Initialized(object sender, EventArgs e)
        {
			datasource.Rows.Add(datasource.CreateFilterViewModel(datasource.Cube.Dimensions.SelectMany(d => d.Hierarchies).FirstOrDefault(h => h.Caption == "Source Currency")));
			datasource.Rows.Add(datasource.CreateFilterViewModel(datasource.Cube.Dimensions.SelectMany(d => d.Hierarchies).FirstOrDefault(h => h.Caption == "Sales Reason")));

			xamPivotGrid1.DataSource = datasource;
			xamPivotDataSelector1.DataSource = datasource;
        }

		private void Button_Click(object sender, RoutedEventArgs e)
		{
            IFilterViewModel fvm1 = (IFilterViewModel)this.xamPivotGrid1.DataSource.Rows[0];
            IFilterViewModel fvm2 = (IFilterViewModel)this.xamPivotGrid1.DataSource.Rows[1];
            Task task1 = this.xamPivotGrid1.DataSource.ExpandToLevelAsync(fvm1, fvm1.Hierarchy.Levels[fvm1.Hierarchy.Levels.Count - 1]);
            Task task2 = this.xamPivotGrid1.DataSource.ExpandToLevelAsync(fvm2, fvm2.Hierarchy.Levels[fvm2.Hierarchy.Levels.Count - 1]);

            Task.Factory.ContinueWhenAll(new Task[] { task1, task2 },
                t => this.xamPivotGrid1.DataSource.RefreshGrid(), 
                TaskContinuationOptions.ExecuteSynchronously);  
		}
    }
}
